#include <fstream>
#include <string>
#include "generr.hh"

using namespace std;

class strange {
private:
  string name;
  int value;
public:
  strange(const char * n, int v) : name(n), value(v) {}
  ~strange() {}
  void out(ostream & o) const {
    o << '(' << name << ", " << value << ')'; }
};

ostream & operator << (
  ostream & o,
  const strange & s
) {
  s.out(o);
  return o;
}

void procedure() {
  GENEX("Self-destructing");
}

void line(
  const char * target
) {
  cerr << "------------------------------ "
       << target << " ------------------------------\n\n";
}

int main() {
  string fileName = "abc.dat";
  const char myName[] = "Maurizio Loreti";
  int i = 42;
  double pig = 3.14;
  strange ss("foo", 666);

  DBGMES("program started");
  line("Trying ERRMES");

  ifstream ifs(fileName.c_str());
  if (!ifs) {
    ERRMES("couldn't open file");
    VALNAM(fileName);
    VALNAM(myName);
    VALNAM(i);
    VALNAM(pig);
    VALNAM(ss);
  }

  cerr << '\n';
  line("Trying GENEX");

  try {
    procedure();
  } catch (const genex & g) {
    cerr << "\t*** Howdy!  I am the General Exception Catcher! "
         << "***\n\n\tI am afraid that, in the line " << g.getLine()
         << " of the file \"" << g.getFile()
         << "\",\n\tsome shit happened in the day of the Lord "
         << g.getDate() << ";\n\tand exactly at " << g.getTime()
         << " (local time, of course).\n\n\tThe message I got is:\t\t\""
         << g.what() << "\"\n\n";
  }

  DBGMES("program ended");
}
